<template>
  <div class="page-container h-full flex-grow flex bg-gray-100" :class="[{'sidebar-open': uiSettings.showSidebar}, 'view-' + uiSettings.activeView]">
    <div class="map-container w-full h-full absolute top-0" :class="{['view-' + uiSettings.activeView]: true, expanded: uiSettings.collapseContent, 'histogram-shown': showHistogram}">
      <MonasteriesMap></MonasteriesMap>
    </div>
    <div v-if="!isMobile" class="overlay sidebar-container z-20 bg-white pt-5" :class="{hide: !uiSettings.showSidebar}">
      <Sidebar></Sidebar>
    </div>
    <div
      class="content-container overlay z-10 flex flex-col flex-1 transition-none"
      :class="[{hide: !uiSettings.showContent, collapsed: uiSettings.collapseContent}, uiSettings.activeView !== 'detail' ? (showHistogram ? 'histogram-shown' : 'pb-14') : '']"
    >
      <router-view @toggle-collapse="toggleCollapse"></router-view>
    </div>
    <div
      v-if="uiSettings.activeView !== 'detail'"
      class="view-switch-container flex justify-center items-center flex-wrap"
    >
      <template v-if="isMobile && uiSettings.showSidebar">
        <Button
          plain
          severity="secondary"
          icon="pi pi-filter"
          label="Filter"
          class="!border-gray-600 !leading-6 mr-2"
          @click="showFilterDialog = true"
        ></Button>
        <Dialog
          title="Filter"
          v-model:visible="showFilterDialog"
          :append-to-body="true"
          modal
          dismissableMask
        >
          <Sidebar class="max-w-[90vw]"></Sidebar>
        </Dialog>
      </template>

      <div class="rounded shadow-md">
        <ListMapToggle :model-value="activeView" @update="onViewSwitch" />
      </div>
    </div>
    <div 
      class="histogram-container overlay bg-inherit z-30 justify-start mb-2 border-t-2"
      :class="[isMobile ? 'pl-4' : 'pl-8 pr-6', {'hide': uiSettings.activeView === 'detail' || !showHistogram}]"
    >
      <Histogram v-model:visible="showHistogram"/>
    </div>
    <Transition name="fade">
      <div
        v-if="uiSettings.activeView !== 'detail' && !showHistogram"
        class="timefilter-button-container"
        >
        <Button
          plain
          severity="secondary"
          icon="pi pi-chart-bar"
          label="Zeitraumfilter"
          :class="['!shadow-xl !rounded-lg h-[40px] !text-inherit !leading-5 !text-sm !p-2', {'!border-gray-600': uiSettings.activeView === 'list'}]"
          @click="showHistogram = true"
        ></Button>
      </div>
    </Transition>
  </div>
</template>

<script>
import Sidebar from '@/components/Sidebar.vue';
import MonasteriesMap from '@/components/MonasteriesMap.vue';
import ListMapToggle from "@/components/ListMapToggle.vue";
import Histogram from '@/components/Histogram.vue';

function mapRouteToUi (path) {
  const uiSettings = {
    activeView: 'list',
    showContent: true,
    showSidebar: true,
    collapseContent: false,
  };

  if (path === '/liste') {
    uiSettings.activeView = 'list';
    uiSettings.showContent = true;
  } else if (path === '/karte') {
    uiSettings.activeView = 'map';
    uiSettings.showContent = false;
  } else if (path.startsWith('/gsn')) {
    uiSettings.activeView = 'detail';
    uiSettings.showContent = true;
    uiSettings.showSidebar = false;
  }
  return uiSettings;
}

const viewRouteMap = {
  list: 'liste',
  map: 'karte',
  detail: 'gsn',
};

export default {
  name: 'Monasteries',
  components: {
    ListMapToggle,
    MonasteriesMap,
    Sidebar,
    Histogram,
  },
  data: () => {
    return {
      uiSettings: {
        showList: true,
        showSidebar: true,
        collapseList: false,
        activeView: null,
      },
      showFilterDialog: false,
      showHistogram: true,
    };
  },
  props: ['params'],
  computed: {
    activeView() {
      return this.$store.state.view;
    },
    isMobile () {
      return this.$store.state.isMobile;
    },
    loadedList () {
      return this.$store.state.loadedList;
    },
    loadingLocations () {
      return this.$store.state.loadingLocations;
    },
    loadedLocations () {
      return this.$store.state.loadedLocations;
    },
    loadedFacets () {
      return this.$store.state.loadedFacetDiocese &&
        this.$store.state.loadedFacetOrder &&
        this.$store.state.loadedFacetGender;
    },
  },
  mounted () {
    this.$store.dispatch('getOrderSymbols');
  },
  beforeRouteEnter (to, from, next) {
    next(vm => {
      vm.uiSettings = mapRouteToUi(to.fullPath);
      vm.$store.dispatch('setView', vm.uiSettings.activeView);
      vm.load();
    });
  },
  beforeRouteUpdate (to, from, next) {
    this.uiSettings = mapRouteToUi(to.fullPath);
    this.$store.dispatch('setView', this.uiSettings.activeView);
    this.load();
    next();
  },
  methods: {
    load () {
      if (this.uiSettings.activeView === 'list' && !this.loadedList) {
        this.$store.dispatch('getMonasteriesList');
      } else if (this.uiSettings.activeView === 'map' && !this.loadedLocations) {
        this.$store.dispatch('getMonasteriesLocations');
      }

      if ((this.uiSettings.activeView === 'list' || this.uiSettings.activeView === 'map') && !this.loadedFacets) {
        this.$store.dispatch('getMonasteriesFacets');
      }
    },
    toggleCollapse () {
      this.uiSettings.collapseContent = !this.uiSettings.collapseContent;
    },
    async onViewSwitch (view) {
      this.$store.dispatch('setView', view);
      await this.$router.push('/' + viewRouteMap[view], { replace: true });
    },

  },
  watch: {
    'uiSettings.activeView': {
      handler: function (newView, oldView) {

      },
    },
  },
};
</script>

<style lang="scss">
.page-container {
  &.view-detail {
    .content-container {
      top: 30%;
      height: 70%;
      @screen lg {
        top: 0;
        height: calc(100vh - theme('height.12'));
      }
    }
  }
}
.map-container {
  z-index: 1;
  height: 100%;
  @screen lg {
    width: calc(100vw - var(--sidebar-width));
    left: var(--sidebar-width);
  }
  
  &.histogram-shown {
    height: calc(100% - var(--histogram-height-tight));
    @screen md {
    height: calc(100% - var(--histogram-height));
    }
    @screen lg {
      height: calc(100% - var(--histogram-height-tight));
    }
    @screen xl {
    height: calc(100% - var(--histogram-height));
    }
  }

  &.view-detail {
    left: 0;
    @screen lg {
      width: var(--sidebar-width);
      height: 100%;
      &.expanded {
        width: var(--sidebar-width) + 35%;
      }
    }
  }
}

.overlay {
  @apply absolute rounded-none;
}



.content-container {
  transition: right 0.3s;
  height: 100%;
  
  &.histogram-shown {
    height: calc(100% - var(--histogram-height-tight));
    @screen md {
      height: calc(100% - var(--histogram-height));
    }
    @screen lg {
      height: calc(100vh - 3rem - var(--histogram-height-tight));
    }
    @screen xl {
      height: calc(100vh - 3rem - var(--histogram-height));
    }
  }

  @apply top-0 right-0 bg-gray-100 w-full;

  @screen lg {
    height: calc(100vh - 3rem);
    width: calc(100vw - var(--sidebar-width));
  }

  &.hide {
    right: -105vw;
    @screen lg {
      right: calc(-105vw + var(--sidebar-width));
    }
  }
  &.collapsed {
    right: calc(-100vw + var(--sidebar-width) + 35%)
  }
}
.sidebar-container {
  width: var(--sidebar-width);
  height: calc(100vh - 3rem);
  left: 0;
  transition: left 0.4s 0.2s;
  &.hide {
    left: calc(-1 * var(--sidebar-width));
  }
}

.fade-enter-active {
  transition: opacity 0.2s;
}
.fade-enter-from {
  opacity: 0;
}

.histogram-container {
  width: 100%;
  height: var(--histogram-height-tight);
  bottom: 0;
  transition: transform 0.2s ease-in-out;
  @screen md {
    height: var(--histogram-height);
  }
  @screen lg {
    left: var(--sidebar-width);
    width: calc(100vw - var(--sidebar-width));
    height: var(--histogram-height-tight);
  }
  @screen xl {
    height: var(--histogram-height);
  }
  &.hide {
    transform: translateY(105%);
  }
}

.view-switch-container {
  position: absolute;
  z-index: 1000;
  right: 0;
  left: 0;
  @apply top-6;

  @screen lg {
    left: auto;
    right: 2rem;
  }

  @screen 2xl {
    left: calc((100vw - var(--sidebar-width)) / 2 + var(--sidebar-width) - 130px);
    right: auto;
  }
}

.timefilter-button-container {
  position: absolute;
  z-index: 1000;
  left: 50%;
  transform: translateX(-50%);
  @apply bottom-6;
  

  @screen lg {
    left: calc(var(--sidebar-width) + (100% - var(--sidebar-width))/2);
    right: auto;
  }
}
</style>
